var timeBetweenClicks = 2000;
// --- intro ---
levelStates.intro= {
  immutable: function() {
    return ({
      progress: 0, spraying: 60, crystal_sound: true,
      stopper: 30,
      spray: new Sprite({
        img: img.spray_sprite, 
        sw: 265, sh: 233, dx: 270, dy: 134, dw: 530, dh: 466
      }) 
    });
  }
}
levelStates.intro.mutable = levelStates.intro.immutable();
function intro() {
  var level = levelStates.intro.mutable;

  if (level.progress == 0) {
    ctx.drawImage(img.cover, 0, 0, 1152, 648, 0, 0, 1152, 648);
    fade.in();
    if (fade.get("progress")==0) level.progress = 1
  } else if (level.progress >= 1 && level.progress < 2) {
    ctx.drawImage(img.cover, 0, 0, 1152, 648, 0, 0, 1152, 648);
  }

  if (level.stopper <= 0 && mouseDown.length > 0) { 
    resetMutableState(current);
    current = "pageOne";
  };

  if (level.stopper > 0) { level.stopper-- };

  helpClick(450, 450);
  //  helpHold(400, 200);

  soundSwitch();
  linker({x: 10, y: 10, w: 142*1.2, h: 157*1.2});
  bgMusic();
};

levelStates.pageOne = {
  immutable: function() {
    return({ 
      imageFadeSpeed: 0.1,
      zoom: 0,
      imageOne: new Sprite({ img: img.page_one_first, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0,
      }),
      imageTwo: new Sprite({ img: img.page_one_two, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageThree: new Sprite({ img: img.page_one_three, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageFour: new Sprite({ img: img.page_one_four, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      progress: 0,
      disableClick: false,
      drawOne: true,
      drawTwo: false,
      drawThree: false,
      drawFour: false,
    });
  }
};
levelStates.pageOne.mutable = levelStates.pageOne.immutable();
function pageOne() {
  var level = levelStates.pageOne.mutable;

  // navigate through level
  if (!level.disableClick && mouseDown.length > 0) { 
    level.progress++;
    level.disableClick=true;
    if (!level.drawFour) {
      mouseDown=[];
    }
  };

  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }

  // draw images
  if (level.progress == 0) {
    fade.in();
    if (fade.get("progress")==0) level.progress = 1
  } else if (level.progress==1) {
    level.drawTwo = true;
  } else if (level.progress==2) {
    level.drawThree = true;
  } else if (level.progress==3) {
    level.drawFour = true;
  }

  // images must be in strict order
  if (level.drawFour) {
    var alfaFour = level.imageFour.get("alfa");
    if (alfaFour<1) { level.imageFour.set({alfa: alfaFour + level.imageFadeSpeed }) };

    // zoom
    if (mouseDown.length > 0 && level.zoom<80) {
      var toZoom = {
        dx: level.imageFour.get("dx"),
        dy: level.imageFour.get("dy"),
        dw: level.imageFour.get("dw"),
        dh: level.imageFour.get("dh"),
      };
      level.imageFour.set({
        dx: toZoom.dx-4, 
        dy: toZoom.dy-8, 
        dw: toZoom.dw+8, 
        dh: toZoom.dh+8, 
      });
      level.zoom++;
    };

    level.imageFour.draw();
    if (mouseDown.length == 0 && level.zoom < 80) { helpHold(700, 440) };
  };

  if (level.drawOne) {
    var alfaOne = level.imageOne.get("alfa");
    if (alfaOne<1) { level.imageOne.set({alfa: alfaOne + level.imageFadeSpeed }) };
    level.imageOne.draw();
  };

  if (level.drawThree) {
    var alfaThree = level.imageThree.get("alfa");
    if (alfaThree<1) { 
      level.imageThree.set({alfa: alfaThree + level.imageFadeSpeed }) 
    };
    level.imageThree.draw();

  };

  if (level.drawTwo) {
    var alfaTwo = level.imageTwo.get("alfa");
    if (alfaTwo<1) { level.imageTwo.set({alfa: alfaTwo + level.imageFadeSpeed }) };
    level.imageTwo.draw();
  };

  // end level
  if (level.zoom>=80) {
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      current="pageTwo";
    }
  };

  if (level.progress < 3) {
    helpClick(450, 450);
  }

  linker({x: 0, y: 0});
  bgMusic();
};

levelStates.pageTwo = {
  immutable: function() {
    return({ 
      imageFadeSpeed: 0.1,
      imageOne: new Sprite({ img: img.page_two_one, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0,
      }),
      imageTwo: new Sprite({ img: img.page_two_two, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageThree: new Sprite({ img: img.page_two_three, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageFour: new Sprite({ img: img.page_two_four, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageFive: new Sprite({ img: img.page_two_five, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageSix: new Sprite({ img: img.page_two_six, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageSeven: new Sprite({ img: img.page_two_seven, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageEight: new Sprite({ img: img.page_two_eight, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageNine: new Sprite({ img: img.page_two_nine, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      progress: 0,
      disableClick: false,
      drawOne: true,
      drawTwo: false,
      drawThree: false,
      drawFour: false,
      drawFive: false,
      drawSix: false,
      drawSeven: false,
      drawEight: false,
      drawNine: false,
      ohhBadEnabled: true
    });
  }
};
levelStates.pageTwo.mutable = levelStates.pageTwo.immutable();
function pageTwo() {
  var level = levelStates.pageTwo.mutable;

  // navigate through level
  if (!level.disableClick && mouseDown.length > 0 && fade.get("progress")==0 && level.progress < 10) { 
    level.progress++;
    level.disableClick=true;
    mouseDown=[];
  };
  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }

  console.log(level.progress)
  // draw images
  if (level.progress == 0) {
    if (soundOn  && level.ohhBadEnabled) {
      snd.ohh_bad.play();
      level.ohhBadEnabled=false;
    }
    fade.in();
    if (fade.get("progress")==0) level.progress = 1
  } else if (level.progress==1) {
    level.drawTwo = true;
  } else if (level.progress==2) {
    level.drawThree = true;
    //  } else if (level.progress==3) {
    level.drawFour = true;
  } else if (level.progress==3) {
    level.drawFive = true;
  } else if (level.progress==4) {
    level.drawSix = true;
  } else if (level.progress==5) {
    level.drawSeven = true;
  } else if (level.progress==6) {
    level.drawEight = true;
  } else if (level.progress==7) {
    level.drawNine = true;
  };

  if (level.drawOne) {
    var alfaOne = level.imageOne.get("alfa");
    if (alfaOne<1) { level.imageOne.set({alfa: alfaOne + level.imageFadeSpeed }) };
    level.imageOne.draw();
  };

  if (level.drawThree) {
    var alfaThree = level.imageThree.get("alfa");
    if (alfaThree<1) { level.imageThree.set({alfa: alfaThree + level.imageFadeSpeed }) };
    level.imageThree.draw();
  };

  if (level.drawFour) {
    var alfaFour = level.imageFour.get("alfa");
    if (alfaFour<1) { level.imageFour.set({alfa: alfaFour + level.imageFadeSpeed }) };
    level.imageFour.draw();
  };

  if (level.drawFive) {
    var alfaFive = level.imageFive.get("alfa");
    if (alfaFive<1) { level.imageFive.set({alfa: alfaFive + level.imageFadeSpeed }) };
    level.imageFive.draw();
  };

  if (level.drawSix) {
    var alfaSix = level.imageSix.get("alfa");
    if (alfaSix<1) { level.imageSix.set({alfa: alfaSix + level.imageFadeSpeed }) };
    level.imageSix.draw();
  };

  if (level.drawNine) {
    var alfaNine = level.imageNine.get("alfa");
    if (alfaNine<1) { level.imageNine.set({alfa: alfaNine + level.imageFadeSpeed }) };
    level.imageNine.draw();
  };

  if (level.drawTwo) {
    var alfaTwo = level.imageTwo.get("alfa");
    if (alfaTwo<1) { level.imageTwo.set({alfa: alfaTwo + level.imageFadeSpeed }) };
    level.imageTwo.draw();
  };

  if (level.drawSeven) {
    var alfaSeven = level.imageSeven.get("alfa");
    if (alfaSeven<1) { level.imageSeven.set({alfa: alfaSeven + level.imageFadeSpeed }) };
    level.imageSeven.draw();
  };

  if (level.drawEight) {
    var alfaEight = level.imageEight.get("alfa");
    if (alfaEight<1) { level.imageEight.set({alfa: alfaEight + level.imageFadeSpeed }) };
    level.imageEight.draw();
  };

  // end level
  if (level.progress>=8) {
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      current="pageThree";
    }
  }

  if (level.progress < 4) {
    soundSwitch();
  }
  bgMusic();
  helpClick(450, 450);
  /*
  if (level.progress >= 5) {
    linker({x: 0, y: 0});
  }
  */
};

levelStates.pageThree = {
  immutable: function() {
    return({ 
      imageFadeSpeed: 0.1,
      imageOne: new Sprite({ img: img.page_three_one, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0,
      }),
      imageTwo: new Sprite({ img: img.page_three_two, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageThree: new Sprite({ img: img.page_three_three, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageFour: new Sprite({ img: img.page_three_four, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageFive: new Sprite({ img: img.page_three_five, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      progress: 0,
      disableClick: false,
      drawOne: true,
      drawTwo: false,
      drawThree: false,
      drawFour: false,
      drawFive: false,
      ohhEnabled: true
    });
  }
};
levelStates.pageThree.mutable = levelStates.pageThree.immutable();
function pageThree() {
  var level = levelStates.pageThree.mutable;
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0) { 
    level.disableClick=true;
    level.progress++;
    mouseDown=[];
  };
  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }

  if (level.progress == 0) {
    fade.in();
    if (fade.get("progress")==0) level.progress = 1
  } else if (level.progress==1) {
    if (soundOn  && level.ohhEnabled) {
      snd.ohh.play();
      level.ohhEnabled=false;
    }
    level.drawTwo = true;
  } else if (level.progress==2) {
    level.drawThree = true;
  } else if (level.progress==3) {
    level.drawFour = true;
  } else if (level.progress==4) {
    level.drawFive = true;
  }

  // draw images
  if (level.drawTwo) {
    var alfaTwo = level.imageTwo.get("alfa");
    if (alfaTwo<1) { level.imageTwo.set({alfa: alfaTwo + level.imageFadeSpeed }) };
    level.imageTwo.draw();
  };

  if (level.drawOne) {
    var alfaOne = level.imageOne.get("alfa");
    if (alfaOne<1) { level.imageOne.set({alfa: alfaOne + level.imageFadeSpeed }) };
    level.imageOne.draw();
  };

  if (level.drawThree) {
    var alfaThree = level.imageThree.get("alfa");
    if (alfaThree<1) { level.imageThree.set({alfa: alfaThree + level.imageFadeSpeed }) };
    level.imageThree.draw();
  };

  if (level.drawFour) {
    var alfaFour = level.imageFour.get("alfa");
    if (alfaFour<1) { level.imageFour.set({alfa: alfaFour + level.imageFadeSpeed }) };
    level.imageFour.draw();
  };

  if (level.drawFive) {
    var alfaFive = level.imageFive.get("alfa");
    if (alfaFive<1) { level.imageFive.set({alfa: alfaFive + level.imageFadeSpeed }) };
    level.imageFive.draw();
  };

  // end level
  if (level.progress>=5) {
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      current="pageFour";
    }
  }

  soundSwitch();
  linker({x: 0, y: 0});
  helpClick(550, 250);
  bgMusic();
};

levelStates.pageFour = {
  immutable: function() {
    return({ 
      imageFadeSpeed: 0.1,
      imageOne: new Sprite({ img: img.page_four_one, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0,
      }),
      imageTwo: new Sprite({ img: img.page_four_two_a, 
        sw: 800, sh: 700, dx: 22, dy: 22, dw: 750/2.4, dh: 657/2.4, alfa: 0
      }),
      bgOne: new Sprite({ img: img.page_four_two_bg, 
        sw: 1199, sh: 594, dw: 600, dh: 300, alfa: 0
      }),
      imageThree: new Sprite({ img: img.page_four_three, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageFour: new Sprite({ img: img.page_four_four, 
        sw: 1199, sh: 594,  dw: 620, dh: 300, alfa: 0, dx: 650,
      }),
      imageFive: new Sprite({ img: img.page_four_five, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageSix: new Sprite({ img: img.page_four_six, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 1
      }),
      imageSeven: new Sprite({ img: img.page_four_seven_a, 
        sw: 1000, sh: 600, dx: 300, dy: 310, dw: 500, dh: 313, alfa: 0
      }),
      bgThree: new Sprite({ img: img.page_four_seven_bg, 
        sw: 2304, sh: 655, dy: 300, dw: 1152, dh: 328, alfa: 0
      }),
      imageEight: new Sprite({ img: img.page_four_eight, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageNine: new Sprite({ img: img.page_four_nine, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageTen: new Sprite({ img: img.page_four_ten, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageEleven: new Sprite({ img: img.page_four_eleven, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      animationOne: 0,
      progress: 0,
      disableClick: false,
      drawOne: true,
      drawTwo: false,
      drawThree: false,
      drawFour: false,
      drawFive: false,
      drawSix: false,
      drawSeven: false,
      drawEight: false,
      drawNine: false,
      drawTen: false,
      drawEleven: false,
    });
  }
};
levelStates.pageFour.mutable = levelStates.pageFour.immutable();
function pageFour() {
  var level = levelStates.pageFour.mutable;
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0 && level.progress != 1) { 
    level.disableClick=true;
    level.progress++;
    mouseDown=[];
  };
  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }

  if (level.progress == 0) {
    fade.in();
    if (fade.get("progress")==0) level.progress = 1
  } else if (level.progress==1) {
    level.drawTwo = true;
  } else if (level.progress==2) {
    level.drawThree = true;
  } else if (level.progress==3) {
    level.drawFour = true;
  } else if (level.progress==4) {
    level.drawFive = true;
  } else if (level.progress==5) {
    level.drawSix = true;
  } else if (level.progress==6) {
    level.drawSeven = true;
  } else if (level.progress==7) {
    level.drawEight = true;
  } else if (level.progress==8) {
    level.drawNine = true;
  } else if (level.progress==9) {
    level.drawTen = true;
  } else if (level.progress==10) {
    level.drawEleven = true;
  }

  // draw images
  if (level.drawTwo) {
    var alfaTwo = level.imageTwo.get("alfa");
    if (alfaTwo<1) { 
      level.imageTwo.set({alfa: alfaTwo + level.imageFadeSpeed });
      level.bgOne.set({alfa: alfaTwo + level.imageFadeSpeed });
    };
    level.bgOne.draw();

    level.imageTwo.draw();

    if (underSec%4==0 && level.animationOne < 5600) {
      level.animationOne += 800;
      level.imageTwo.set({sx: level.animationOne});
    } else if (level.animationOne >= 5600) {
      if (!level.drawThree && underSec == 1) {
        level.progress = 2; 
      }
    };
  };

  if (level.drawFour) {
    var alfaFour = level.imageFour.get("alfa");
    if (alfaFour<1) { 
      level.imageFour.set({alfa: alfaFour + level.imageFadeSpeed });
    };
    level.imageFour.draw();
  };
  if (level.drawOne && !level.drawSix) {
    var alfaOne = level.imageOne.get("alfa");
    if (alfaOne<1) { level.imageOne.set({alfa: alfaOne + level.imageFadeSpeed }) };
    level.imageOne.draw();
  };
  if (level.drawSeven) {
    var alfaSeven = level.imageSeven.get("alfa");
    if (alfaSeven<1) { level.imageSeven.set({alfa: alfaSeven + level.imageFadeSpeed }) };
    level.bgThree.set({alfa: alfaThree + level.imageFadeSpeed });
    level.bgThree.draw();

    level.imageSeven.animate({num: 10});
    level.imageSeven.draw();
  };



  if (level.drawThree && !level.drawSix) {
    var alfaThree = level.imageThree.get("alfa");
    if (alfaThree<1) { level.imageThree.set({alfa: alfaThree + level.imageFadeSpeed }) };
    level.imageThree.draw();
  };

  if (level.drawFive && !level.drawSix) {
    var alfaFive = level.imageFive.get("alfa");
    if (alfaFive<1) { level.imageFive.set({alfa: alfaFive + level.imageFadeSpeed }) };
    level.imageFive.draw();
  };

  if (level.drawSix) {
    level.imageSix.draw();
  };
  if (level.drawEight) {
    var alfaEight = level.imageEight.get("alfa");
    if (alfaEight<1) { level.imageEight.set({alfa: alfaEight + level.imageFadeSpeed }) };
    level.imageEight.draw();
  };
  if (level.drawNine) {
    var alfaNine = level.imageNine.get("alfa");
    if (alfaNine<1) { level.imageNine.set({alfa: alfaNine + level.imageFadeSpeed }) };
    level.imageNine.draw();
  };
  if (level.drawTen) {
    var alfaTen = level.imageTen.get("alfa");
    if (alfaTen<1) { level.imageTen.set({alfa: alfaTen + level.imageFadeSpeed }) };
    level.imageTen.draw();
  };
  if (level.drawEleven) {
    var alfaEleven = level.imageEleven.get("alfa");
    if (alfaEleven<1) { level.imageEleven.set({alfa: alfaEleven + level.imageFadeSpeed }) };
    level.imageEleven.draw();
  };

  // end level
  if (level.progress>=11) {
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      current="pageFive";
    }
  }

  if (level.progress > 3) {
    linker({x: 0, y: 0});
  }
  soundSwitch();

  if (level.progress>1) { helpClick(270, 450) };
  bgMusic();
};

levelStates.pageFive = {
  immutable: function() {
    return({ 
      imageFadeSpeed: 0.1,
      imageOne: new Sprite({ img: img.page_five_one, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageTwo: new Sprite({ img: img.page_five_two, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageThree: new Sprite({ img: img.page_five_three, 
        sw: 1152, sh: 648, dw: 1152, dh: 648, alfa: 0
      }),
      imageFour: new Sprite({ img: img.page_five_four, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageFive: new Sprite({ img: img.page_five_five, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageSix: new Sprite({ img: img.page_five_six, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageSeven: new Sprite({ img: img.page_five_seven, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      progress: 0,
      disableClick: false,
      drawOne: true,
      drawTwo: false,
      drawThree: false,
      drawFour: false,
      drawFive: false,
      drawSix: false,
      drawSeven: false,
    });
  }
};
levelStates.pageFive.mutable = levelStates.pageFive.immutable();

function pageFive() {
  var level = levelStates.pageFive.mutable;
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0) { 
    level.disableClick=true;
    level.progress++;
    mouseDown=[];
  };
  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }

  if (level.progress == 0) {
    fade.in();
    if (fade.get("progress")==0) level.progress = 1
  } else if (level.progress==1) {
    level.drawTwo = true;
  } else if (level.progress==2) {
    level.drawThree = true;
  } else if (level.progress==3) {
    level.drawFour = true;
  } else if (level.progress==4) {
    level.drawFive = true;
  } else if (level.progress==5) {
    level.drawSix = true;
  } else if (level.progress==6) {
    level.drawSeven = true;
  }

  if (level.drawThree) {
    var alfaThree = level.imageThree.get("alfa");
    if (alfaThree<1) { level.imageThree.set({alfa: alfaThree + level.imageFadeSpeed }) };
    level.imageThree.draw();
  };

  if (level.drawOne) {
    var alfaOne = level.imageOne.get("alfa");
    if (alfaOne<1) { level.imageOne.set({alfa: alfaOne + level.imageFadeSpeed }) };
    level.imageOne.draw();
  };

  if (level.drawTwo) {
    var alfaTwo = level.imageTwo.get("alfa");
    if (alfaTwo<1) { level.imageTwo.set({alfa: alfaTwo + level.imageFadeSpeed }) };
    level.imageTwo.draw();
  };

  if (level.drawFour) {
    var alfaFour = level.imageFour.get("alfa");
    if (alfaFour<1) { level.imageFour.set({alfa: alfaFour + level.imageFadeSpeed }) };
    level.imageFour.draw();
  };

  if (level.drawFive) {
    var alfaFive = level.imageFive.get("alfa");
    if (alfaFive<1) { level.imageFive.set({alfa: alfaFive + level.imageFadeSpeed }) };
    level.imageFive.draw();
  };

  if (level.drawSix) {
    var alfaSix = level.imageSix.get("alfa");
    if (alfaSix<1) { level.imageSix.set({alfa: alfaSix + level.imageFadeSpeed }) };
    level.imageSix.draw();
  };

  if (level.drawSeven) {
    var alfaSeven = level.imageSeven.get("alfa");
    if (alfaSeven<1) { level.imageSeven.set({alfa: alfaSeven + level.imageFadeSpeed }) };
    level.imageSeven.draw();
  };

  // end level
  if (level.progress>=7) {
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      current="pageSix";
    }
  }

  //  soundSwitch();
  linker({x: 0, y: 0});
  if (level.progress>=1) { helpClick(70, 450) };
  bgMusic();
};

levelStates.pageSix = {
  immutable: function() {
    return({ 
      imageFadeSpeed: 0.1,
      imageOne: new Sprite({ img: img.page_six_one, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageTwo: new Sprite({ img: img.page_six_two, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageThree: new Sprite({ img: img.page_six_three, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageFour: new Sprite({ img: img.page_six_four, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageFive: new Sprite({ img: img.page_six_five, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageSix: new Sprite({ img: img.page_six_six, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageSeven: new Sprite({ img: img.page_six_seven, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageEight: new Sprite({ img: img.page_six_eight, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      progress: 0,
      disableClick: false,
      drawOne: true,
      drawTwo: false,
      drawThree: false,
      drawFour: false,
      drawFive: false,
      drawSix: false,
      drawSeven: false,
      drawEight: false,
      ohhMaleEnabled: true
    });
  }
};
levelStates.pageSix.mutable = levelStates.pageSix.immutable();

function pageSix() {
  var level = levelStates.pageSix.mutable;
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0) { 
    level.disableClick=true;
    level.progress++;
    mouseDown=[];
  };
  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }

  if (level.progress == 0) {
    fade.in();
    if (fade.get("progress")==0) level.progress = 1
  } else if (level.progress==1) {
    level.drawTwo = true;
  } else if (level.progress==2) {
    level.drawThree = true;
  } else if (level.progress==3) {
    level.drawFour = true;
  } else if (level.progress==4) {
    level.drawFive = true;
  } else if (level.progress==5) {
    level.drawSix = true;
  } else if (level.progress==6) {
    level.drawSeven = true;
  } else if (level.progress==7) {
    level.drawEight = true;
    if (soundOn  && level.ohhMaleEnabled) {
      setTimeout(function(){
        snd.ohh_male.play();
        level.ohhMaleEnabled=false;
      }, 1000);
    }
  }

  if (level.drawTwo) {
    var alfaTwo = level.imageTwo.get("alfa");
    if (alfaTwo<1) { level.imageTwo.set({alfa: alfaTwo + level.imageFadeSpeed }) };
    level.imageTwo.draw();
  };

  if (level.drawOne) {
    var alfaOne = level.imageOne.get("alfa");
    if (alfaOne<1) { level.imageOne.set({alfa: alfaOne + level.imageFadeSpeed }) };
    level.imageOne.draw();
  };

  if (level.drawThree) {
    var alfaThree = level.imageThree.get("alfa");
    if (alfaThree<1) { level.imageThree.set({alfa: alfaThree + level.imageFadeSpeed }) };
    level.imageThree.draw();
  };

  if (level.drawFour) {
    var alfaFour = level.imageFour.get("alfa");
    if (alfaFour<1) { level.imageFour.set({alfa: alfaFour + level.imageFadeSpeed }) };
    level.imageFour.draw();
  };

  if (level.drawFive) {
    var alfaFive = level.imageFive.get("alfa");
    if (alfaFive<1) { level.imageFive.set({alfa: alfaFive + level.imageFadeSpeed }) };
    level.imageFive.draw();
  };

  if (level.drawSix) {
    var alfaSix = level.imageSix.get("alfa");
    if (alfaSix<1) { level.imageSix.set({alfa: alfaSix + level.imageFadeSpeed }) };
    level.imageSix.draw();
  };

  if (level.drawSeven) {
    var alfaSeven = level.imageSeven.get("alfa");
    if (alfaSeven<1) { level.imageSeven.set({alfa: alfaSeven + level.imageFadeSpeed }) };
    level.imageSeven.draw();
  };

  if (level.drawEight) {
    var alfaEight = level.imageEight.get("alfa");
    level.imageEight.draw();
    if (alfaEight<1) { 
      level.imageEight.set({alfa: alfaEight + level.imageFadeSpeed });
    } else {
      var oldDx = level.imageEight.get('dx');
      if (oldDx < 450) {
        var newDx = oldDx + 20;
        level.imageEight.set({dx: newDx });
      } else {
        // end level
        fade.out();
        if (fade.get("progress")==100) {
          resetMutableState(current);
          current="pageSeven";
        }
      }
    }
  };

  bgMusic();
  helpClick(450, 450);
  //  soundSwitch();
  //linker({x: 0, y: 0});
};

levelStates.pageSeven = {
  immutable: function() {
    return({ 
      imageFadeSpeed: 0.1,
      imageOne: new Sprite({ img: img.page_seven_one, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageTwo: new Sprite({ img: img.page_seven_two, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageThree: new Sprite({ img: img.page_seven_three, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageFour: new Sprite({ img: img.page_seven_four, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageFive: new Sprite({ img: img.page_seven_five, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageSix: new Sprite({ img: img.page_seven_six, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageSeven: new Sprite({ img: img.page_seven_seven, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageEight: new Sprite({ img: img.page_seven_eight, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageNine: new Sprite({ img: img.page_seven_nine, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageTen: new Sprite({ img: img.page_seven_ten, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageEleven: new Sprite({ img: img.page_seven_eleven, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageTwelve: new Sprite({ img: img.page_seven_twelve, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      progress: 0,
      disableClick: false,
      drawOne: true,
      drawTwo: false,
      drawThree: false,
      drawFour: false,
      drawFive: false,
      drawSix: false,
      drawSeven: false,
      drawEight: false,
      drawNine: false,
      drawTen: false,
      drawEleven: false,
      drawTwelve: false,
    });
  }
};
levelStates.pageSeven.mutable = levelStates.pageSeven.immutable();

function pageSeven() {
  var level = levelStates.pageSeven.mutable;
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0) { 
    level.disableClick=true;
    level.progress++;
    mouseDown=[];
  };
  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }

  if (level.progress == 0) {
    fade.in();
    if (fade.get("progress")==0) level.progress = 1
  } else if (level.progress==1) {
    level.drawTwo = true;
    //  } else if (level.progress==2) {
    level.drawThree = true;
  } else if (level.progress==2) {
    level.drawFour = true;
  } else if (level.progress==3) {
    level.drawFive = true;
  } else if (level.progress==4) {
    level.drawSix = true;
  } else if (level.progress==5) {
    level.drawSeven = true;
  } else if (level.progress==6) {
    level.drawEight = true;
  } else if (level.progress==7) {
    level.drawNine = true;
  } else if (level.progress==8) {
    level.drawTen = true;
  } else if (level.progress==9) {
    level.drawEleven = true;
  } else if (level.progress==10) {
    level.drawTwelve = true;
  };

  if (level.drawOne) {
    var alfaOne = level.imageOne.get("alfa");
    if (alfaOne<1) { level.imageOne.set({alfa: alfaOne + level.imageFadeSpeed }) };
    level.imageOne.draw();
  };

  if (level.drawTwo) {
    var alfaTwo = level.imageTwo.get("alfa");
    if (alfaTwo<1) { level.imageTwo.set({alfa: alfaTwo + level.imageFadeSpeed }) };
    level.imageTwo.draw();
  };

  if (level.drawThree) {
    var alfaThree = level.imageThree.get("alfa");
    if (alfaThree<1) { level.imageThree.set({alfa: alfaThree + level.imageFadeSpeed }) };
    level.imageThree.draw();
  };

  if (level.drawFour) {
    var alfaFour = level.imageFour.get("alfa");
    if (alfaFour<1) { level.imageFour.set({alfa: alfaFour + level.imageFadeSpeed }) };
    level.imageFour.draw();
  };

  if (level.drawFive) {
    var alfaFive = level.imageFive.get("alfa");
    if (alfaFive<1) { level.imageFive.set({alfa: alfaFive + level.imageFadeSpeed }) };
    level.imageFive.draw();
  };

  if (level.drawSix) {
    var alfaSix = level.imageSix.get("alfa");
    if (alfaSix<1) { level.imageSix.set({alfa: alfaSix + level.imageFadeSpeed }) };
    level.imageSix.draw();
  };

  if (level.drawSeven) {
    var alfaSeven = level.imageSeven.get("alfa");
    if (alfaSeven<1) { level.imageSeven.set({alfa: alfaSeven + level.imageFadeSpeed }) };
    level.imageSeven.draw();
  };

  if (level.drawEight) {
    var alfaEight = level.imageEight.get("alfa");
    if (alfaEight<1) { level.imageEight.set({alfa: alfaEight + level.imageFadeSpeed }) };
    level.imageEight.draw();
  };

  if (level.drawNine) {
    var alfaNine = level.imageNine.get("alfa");
    if (alfaNine<1) { level.imageNine.set({alfa: alfaNine + level.imageFadeSpeed }) };
    level.imageNine.draw();
  };

  if (level.drawTen) {
    var alfaTen = level.imageTen.get("alfa");
    if (alfaTen<1) { level.imageTen.set({alfa: alfaTen + level.imageFadeSpeed }) };
    level.imageTen.draw();
  };

  if (level.drawEleven) {
    var alfaEleven = level.imageEleven.get("alfa");
    if (alfaEleven<1) { level.imageEleven.set({alfa: alfaEleven + level.imageFadeSpeed }) };
    level.imageEleven.draw();
  };

  if (level.drawTwelve) {
    var alfaTwelve = level.imageTwelve.get("alfa");
    if (alfaTwelve<1) { level.imageTwelve.set({alfa: alfaTwelve + level.imageFadeSpeed }) };
    level.imageTwelve.draw();
  };

  // end level
  if (level.progress>=11) {
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      current="pageEight";
    }
  }

  if (level.progress < 2) {
    soundSwitch();
  }
  linker({x: 0, y: 30});
  helpClick(750, 450);
  bgMusic();
};

levelStates.pageEight = {
  immutable: function() {
    return({ 
      imageFadeSpeed: 0.1,
      imageOne: new Sprite({ img: img.page_eight_one, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageTwo: new Sprite({ img: img.page_eight_two, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageThreeBg: new Sprite({ img: img.page_eight_three_bg, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageThreeArm: new Sprite({ img: img.page_eight_three_arm, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageThreeMask: new Sprite({ img: img.page_eight_three_mask, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 1
      }),
      imageFour: new Sprite({ img: img.page_eight_four, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageFive: new Sprite({ img: img.page_eight_five, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageSix: new Sprite({ img: img.page_eight_six, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageSeven: new Sprite({ img: img.page_eight_seven, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageEight: new Sprite({ img: img.page_eight_eight, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      progress: 0,
      pull: 0,
      maxPull: 68,
      disableClick: false,
      drawOne: true,
      drawTwo: false,
      drawThree: false,
      drawFour: false,
      drawFive: false,
      drawSix: false,
      drawSeven: false,
      drawEight: false,
    });
  }
};
levelStates.pageEight.mutable = levelStates.pageEight.immutable();

function pageEight() {
  var level = levelStates.pageEight.mutable;
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0 && level.progress != 4) { 
    level.disableClick=true;
    level.progress++;
    mouseDown=[];
  };
  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }

  if (level.progress == 0) {
    fade.in();
    if (fade.get("progress")==0) level.progress = 1
  } else if (level.progress==2) {
    level.drawTwo = true;
  } else if (level.progress==3) {
    level.drawThree = true;
  } else if (level.progress==4) {
    if (level.pull < level.maxPull) {
      if (mouseDown.length > 0) { 
        level.pull += 1;
      } else {
        if (level.pull>0) {
          level.pull -= 1;
        }
      };
      level.imageThreeArm.set({dx: level.pull });
    } else {
      level.progress=5
      level.drawFour = true
    };
  } else if (level.progress==7) {
    level.drawFive = true;
  } else if (level.progress==8) {
    level.drawSix = true;
  } else if (level.progress==9) {
    level.drawSeven = true;
  } else if (level.progress==10) {
    level.drawEight = true;
  } else if (level.progress==11) {
    level.drawEight = true;
  } else if (level.progress>=12) {
    resetMutableState(current);
    current="pageNine";
  };

  if (level.drawOne) {
    var alfaOne = level.imageOne.get("alfa");
    if (alfaOne<1) { level.imageOne.set({alfa: alfaOne + level.imageFadeSpeed }) };
    level.imageOne.draw();
  };

  if (level.drawTwo) {
    var alfaTwo = level.imageTwo.get("alfa");
    if (alfaTwo<1) { level.imageTwo.set({alfa: alfaTwo + level.imageFadeSpeed }) };
    level.imageTwo.draw();
  };

  if (level.drawThree) {
    var alfaThree = level.imageThreeBg.get("alfa");
    if (alfaThree<1) { 
      level.imageThreeBg.set({alfa: alfaThree + level.imageFadeSpeed });
      level.imageThreeArm.set({alfa: alfaThree + level.imageFadeSpeed });
    };
    level.imageThreeBg.draw();
    level.imageThreeArm.draw();
    level.imageThreeMask.draw();

    if (!mouseDown.length) { helpHold(770, 450) };
  };

  if (level.drawFour) {
    var alfaFour = level.imageFour.get("alfa");
    if (alfaFour<1) { level.imageFour.set({alfa: alfaFour + level.imageFadeSpeed }) };
    level.imageFour.draw();
  };
  if (level.drawFive) {
    var alfaFive = level.imageFive.get("alfa");
    if (alfaFive<1) { level.imageFive.set({alfa: alfaFive + level.imageFadeSpeed }) };
    level.imageFive.draw();
  };
  if (level.drawSix) {
    var alfaSix = level.imageSix.get("alfa");
    if (alfaSix<1) { level.imageSix.set({alfa: alfaSix + level.imageFadeSpeed }) };
    level.imageSix.draw();
  };
  if (level.drawSeven) {
    var alfaSeven = level.imageSeven.get("alfa");
    if (alfaSeven<1) { level.imageSeven.set({alfa: alfaSeven + level.imageFadeSpeed }) };
    level.imageSeven.draw();
  };
  if (level.drawEight) {
    var alfaEight = level.imageEight.get("alfa");
    if (alfaEight<1) { level.imageEight.set({alfa: alfaEight + level.imageFadeSpeed }) };
    level.imageEight.draw();
  };

  linker({x: 0, y: 0});
  soundSwitch();
  bgMusic();

  if (level.progress < 4 || level.progress >= 5) { helpClick(650, 450) };
};

levelStates.pageNine = {
  immutable: function() {
    return({ 
      imageFadeSpeed: 0.1,
      imageOne: new Sprite({ img: img.page_nine_one, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageTwo: new Sprite({ img: img.page_nine_two, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageThree: new Sprite({ img: img.page_nine_three, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageFour: new Sprite({ img: img.page_nine_four, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageFive: new Sprite({ img: img.page_nine_five, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageSix: new Sprite({ img: img.page_nine_six, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageSeven: new Sprite({ img: img.page_nine_seven, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageEight: new Sprite({ img: img.page_nine_eight, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      progress: 0,
      disableClick: false,
      drawOne: true,
      drawTwo: false,
      drawThree: false,
      drawFour: false,
      drawFive: false,
      drawSix: false,
      drawSeven: false,
      drawEight: false,
    });
  }
};
levelStates.pageNine.mutable = levelStates.pageNine.immutable();

function pageNine() {
  var level = levelStates.pageNine.mutable;
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0) { 
    level.disableClick=true;
    level.progress++;
    mouseDown=[];
  };
  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }

  if (level.progress == 0) {
    fade.in();
    if (fade.get("progress")==0) level.progress = 2
  } else if (level.progress==2) {
    level.drawTwo = true;
  } else if (level.progress==3) {
    level.drawThree = true;
  } else if (level.progress==4) {
    level.drawFour = true;
  } else if (level.progress==5) {
    level.drawFive = true;
  } else if (level.progress==6) {
    level.drawSix = true;
  } else if (level.progress==7) {
    level.drawSeven = true;
  } else if (level.progress==8) {
    level.drawEight = true;
  } else if (level.progress==9) {
    level.drawEight = true;
  } else if (level.progress>=9) {
    resetMutableState(current);
    current="pageTen";
  };

  if (level.drawOne) {
    var alfaOne = level.imageOne.get("alfa");
    if (alfaOne<1) { level.imageOne.set({alfa: alfaOne + level.imageFadeSpeed }) };
    level.imageOne.draw();
  };

  if (level.drawTwo) {
    var alfaTwo = level.imageTwo.get("alfa");
    if (alfaTwo<1) { level.imageTwo.set({alfa: alfaTwo + level.imageFadeSpeed }) };
    level.imageTwo.draw();
  };

  if (level.drawThree) {
    var alfaThree = level.imageThree.get("alfa");
    if (alfaThree<1) { level.imageThree.set({alfa: alfaThree + level.imageFadeSpeed }) };
    level.imageThree.draw();
  };

  if (level.drawFour) {
    var alfaFour = level.imageFour.get("alfa");
    if (alfaFour<1) { level.imageFour.set({alfa: alfaFour + level.imageFadeSpeed }) };
    level.imageFour.draw();
  };
  if (level.drawFive) {
    var alfaFive = level.imageFive.get("alfa");
    if (alfaFive<1) { level.imageFive.set({alfa: alfaFive + level.imageFadeSpeed }) };
    level.imageFive.draw();
  };
  if (level.drawSix) {
    var alfaSix = level.imageSix.get("alfa");
    if (alfaSix<1) { level.imageSix.set({alfa: alfaSix + level.imageFadeSpeed }) };
    level.imageSix.draw();
  };
  if (level.drawSeven) {
    var alfaSeven = level.imageSeven.get("alfa");
    if (alfaSeven<1) { level.imageSeven.set({alfa: alfaSeven + level.imageFadeSpeed }) };
    level.imageSeven.draw();
  };
  if (level.drawEight) {
    var alfaEight = level.imageEight.get("alfa");
    if (alfaEight<1) { level.imageEight.set({alfa: alfaEight + level.imageFadeSpeed }) };
    level.imageEight.draw();
  };

  linker({x: 0, y: 0});
  if (level.progress < 4) {
    soundSwitch();
  }
  bgMusic();

  helpClick(500, 450);
};

levelStates.pageTen = {
  immutable: function() {
    return({ 
      imageFadeSpeed: 0.1,
      imageOne: new Sprite({ img: img.page_ten_one, 
        sw: 1152, sh: 1293, dx: 300, dw: 576, dh: 648, alfa: 0
      }),
      imageTwo: new Sprite({ img: img.page_ten_two, 
        sw: 1152, sh: 1293, dx: 300, dw: 576, dh: 648, alfa: 0
      }),
      imageThree: new Sprite({ img: img.page_ten_three, 
        sw: 1152, sh: 1293, dx: 300, dw: 576, dh: 648, alfa: 0
      }),
      imageFour: new Sprite({ img: img.page_ten_four, 
        sw: 1152, sh: 1293, dx: 300, dw: 576, dh: 648, alfa: 1
      }),
      blowBar: new Bar({
        x: 50, y: 448, w: 250, h: 50, text: "", 
        percent: 1, fillC: "yellow"
      }),
      progress: 0,
      disableClick: true,
      drawImageOne: true,
      drawImageTwo: false,
      drawImageThree: false,
      drawImageFour: false,
      bushMove: 0,
      bushMaxMove: 400,
      animate: false,
      sucking1Enabled: true,
      sucking2Enabled: true,
      sucking3Enabled: true,
    });
  }
};

levelStates.pageTen.mutable = levelStates.pageTen.immutable();

function pageTen() {
  var level = levelStates.pageTen.mutable;

  // navigate through level
  if (!level.disableClick && mouseDown.length > 0 && level.progress < 5) { 
    level.animate=true;
    level.blowBar.changeBy(0.5);
  } else {
    level.animate=false;
    if (level.progress < 5) {
      level.blowBar.changeBy(-1);
    }
  };

  if (level.blowBar.get('percent') == 100) {
    level.blowBar.set({percent: 0});
    level.progress++;
  }

  if (level.drawImageOne) {
    var alfaOne = level.imageOne.get("alfa");
    if (alfaOne<1) { level.imageOne.set({alfa: alfaOne + level.imageFadeSpeed }) };
    if (level.animate) { 
      level.imageOne.animate({num: 10});
      if (soundOn) { snd.sucking_1.play() }
    } else {
      snd.sucking_1.pause();
    }
    level.imageOne.draw();
  };

  if (level.drawImageTwo) {
    var alfaTwo = level.imageTwo.get("alfa");
    if (alfaTwo<1) { 
      level.imageTwo.set({alfa: alfaTwo + level.imageFadeSpeed }) 
    } else {
      level.drawImageOne=false;
    }
    if (level.animate) { 
      level.imageTwo.animate({num: 10})
      if (soundOn) { snd.sucking_2.play() }
    } else {
      snd.sucking_2.pause();
    }
    level.imageTwo.draw();
  };

  if (level.drawImageThree) {
    var alfaThree = level.imageThree.get("alfa");
    if (alfaThree<1) { 
      level.imageThree.set({alfa: alfaThree + level.imageFadeSpeed }) 
    } else {
      level.drawImageTwo=false;
    }

    if (level.animate) { 
      level.imageThree.animate({num: 10});
      if (soundOn) { snd.sucking_3.play() }
    } else {
      snd.sucking_3.pause();
    }
    level.imageThree.draw();
  };

  if (level.drawImageFour) {
    level.imageFour.draw();
  };

  // bushes
  if (level.bushMove < level.bushMaxMove) {
    level.bushMove+=10;
    level.disableClick = true;

    if (soundOn) { 
      snd.bush.play() 
    }
  } else {
    level.disableClick = false;
  };

  // bushes
  ctx.drawImage(img.page_ten_foreground_one, 0, 0, 1152, 648, level.bushMove*1.05, 0, 1152, 648);
  ctx.drawImage(img.page_ten_foreground_two, 0, 0, 1152, 648, level.bushMove*(-1.05), 0, 1152, 648);

  // border
  ctx.drawImage(img.page_ten_one_border, 0, 0, 2303, 1296, 0, 0, 1152, 648);

  if (level.progress<6) {
    level.blowBar.draw();
  } else {
    ctx.drawImage(img.page_ten_two_border, 0, 0, 2303, 1296, 0, 0, 1152, 648);
  };


  if (level.progress == 0) {
    level.drawImageOne=true;
    level.drawImageTwo=false;
    level.drawImageThree=false;
    fade.in();
    if (fade.get("progress")==0) level.progress = 2
  } else if (level.progress==2) {
    level.drawImageOne=true;
    level.drawImageTwo=false;
    level.drawImageThree=false;
  } else if (level.progress==3) {
    level.drawImageTwo=true;
    level.drawImageThree=false;
    level.blowBar.set({fillC: 'orange'});
  } else if (level.progress==4) {
    level.drawImageThree=true;
    level.blowBar.set({fillC: 'red'});
  } else if (level.progress==5) {
    fade.out();
    if (fade.get("progress")==100) {
      level.progress = 6;
      level.drawImageThree = false;
      level.drawImageFour = true;
    }
  } else if (level.progress==6) {
    level.drawImageFour = true;
    fade.in();
    if (fade.get("progress")==0) level.progress = 7
  } else if (level.progress==7) {
    setTimeout(function(){ level.progress=8}, 1500);
  } else if (level.progress>=8) {
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      current="pageEleven";
    }
  }

  linker({x: 0, y: 0});
  soundSwitch();
  bgMusic();

  if (level.bushMove >= level.bushMaxMove && !mouseDown.length && level.progress < 5) {
    helpHold(900, 450);
  }

};

levelStates.pageEleven = {
  immutable: function() {
    return({ 
      imageFadeSpeed: 0.1,
      imageAnimation: new Sprite({ img: img.page_eleven_animation, 
        sw: 2304, sh: 1296, dw: 1152, dh: 648
      }),
      imageOne: new Sprite({ img: img.page_eleven_one, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageTwo: new Sprite({ img: img.page_eleven_two, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageThree: new Sprite({ img: img.page_eleven_three, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      progress: 0,
      drawOne: false,
      drawTwo: false,
      drawThree: false,
      disableClick: false,
      drawOne: true,
    });
  }
};
levelStates.pageEleven.mutable = levelStates.pageEleven.immutable();

function pageEleven() {
  var level = levelStates.pageEleven.mutable;
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0) { 
    level.disableClick=true;
    level.progress++;
    mouseDown=[];
  };
  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }

  level.imageAnimation.animate({num: 5});
  level.imageAnimation.draw();

  if (level.drawOne) {
    var alfaOne = level.imageOne.get("alfa");
    if (alfaOne<1) { level.imageOne.set({alfa: alfaOne + level.imageFadeSpeed }) };
    level.imageOne.draw();
  };

  if (level.drawTwo) {
    var alfaTwo = level.imageTwo.get("alfa");
    if (alfaTwo<1) { level.imageTwo.set({alfa: alfaTwo + level.imageFadeSpeed }) };
    level.imageTwo.draw();
  };

  if (level.drawThree) {
    var alfaThree = level.imageThree.get("alfa");
    if (alfaThree<1) { level.imageThree.set({alfa: alfaThree + level.imageFadeSpeed }) };
    level.imageThree.draw();
  };

  if (level.progress == 0) {
    fade.in();
    if (fade.get("progress")==0) level.progress = 2
  } else if (level.progress==2) {
    level.drawOne = true;
  } else if (level.progress==3) {
    level.drawTwo = true;
  } else if (level.progress==4) {
    level.drawThree = true;
  };

  if (level.progress < 4) {
    if (soundOn) { snd.sucking_male_2.play() }
  }

  // end level
  if (level.progress>=5) {
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      current="pageTwelve";
    }
  }
  linker({x: 0, y: 0});
  soundSwitch();
  bgMusic();
  helpClick(250, 450);
};

levelStates.pageTwelve = {
  immutable: function() {
    return({ 
      imageFadeSpeed: 0.1,
      imageAnimationOne: new Sprite({ img: img.sex_animation_one, 
        sw: 2304, sh: 1296, dw: 1152, dh: 648
      }),
      imageAnimationTwo: new Sprite({ img: img.sex_animation_two, 
        sw: 2304, sh: 1296, dw: 1152, dh: 648
      }),
      imageOne: new Sprite({ img: img.page_twelve_one, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 1
      }),
      imageTwo: new Sprite({ img: img.page_twelve_two, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageThree: new Sprite({ img: img.page_twelve_three, 
        sw: 2303, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      drawAnimationOne: true,
      drawAnimationTwo: false,
      progress: 0,
      drawTwo: false,
      drawThree: false,
      disableClick: false,
      drawOne: true,
      animate: false,
      sexBar: new Bar({
        x: 820, y: 230, w: 250, h: 100, text: "", 
        percent: 20, fillC: "red"
      }),
    });
  }
};
levelStates.pageTwelve.mutable = levelStates.pageTwelve.immutable();

function pageTwelve() {
  var level = levelStates.pageTwelve.mutable;
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0 && level.progress < 5) { 
    level.disableClick=true;
    level.progress++;
    mouseDown=[];
  };

  if (level.progress >= 5) {
    if (mouseDown.length > 0) { 
      level.animate=true;
      level.sexBar.changeBy(0.25);
    } else {
      level.animate=false;
      level.sexBar.changeBy(-1);
    };
  }


  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }

  if (level.drawAnimationOne) {
    level.imageAnimationOne.animate({num: 4});
    level.imageAnimationOne.draw();
  }

  if (level.drawAnimationTwo) {
    if (level.animate) {
      level.imageAnimationTwo.animate({num: 8});
      if (soundOn) { 
        snd.sex_female.play();
        snd.sex_male.play();
      }
    } else {
      snd.sex_female.pause();
      snd.sex_male.pause();
    }
    level.imageAnimationTwo.draw();
  }

  level.imageOne.draw();

  if (level.drawTwo) {
    var alfaTwo = level.imageTwo.get("alfa");
    if (alfaTwo<1) { level.imageTwo.set({alfa: alfaTwo + level.imageFadeSpeed }) };
    level.imageTwo.draw();
  };

  if (level.drawThree) {
    var alfaThree = level.imageThree.get("alfa");
    if (alfaThree<1) { level.imageThree.set({alfa: alfaThree + level.imageFadeSpeed }) };
    level.imageThree.draw();
  };

  if (level.sexBar.get('percent') == 100) {
    level.sexBar.set({percent: 0});
    level.progress++;
  }

  if (level.progress == 0) {
    fade.in();
    if (fade.get("progress")==0) level.progress = 2
  } else if (level.progress==2) {
  } else if (level.progress==3) {
    level.drawTwo = true;
  } else if (level.progress==4) {
    level.drawThree = true;
  } else if (level.progress==5) {
    level.drawAnimationOne = false;
    level.drawAnimationTwo = true;

    level.sexBar.draw();

    if (level.sexBar.get('percent') == 100) {
      level.progress=6 
    }
  } else if (level.progress>=6) {
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      current="pageThirteen";
    }
  }
  linker({x: 0, y: 0});
  soundSwitch();
  bgMusic();

  if (level.progress < 5) {
    helpClick(250, 450);
  };

  if (level.progress >= 5 && level.progress < 6 && !mouseDown.length) {
    helpHold(250, 450);
  };
};

levelStates.pageThirteen = {
  immutable: function() {
    return({ 
      imageFadeSpeed: 0.1,
      imageOne: new Sprite({ img: img.page_thirteen_one, 
        sw: 2304, sh: 1296, dw: 1152, dh: 648, alfa: 1
      }),
      imageTwo: new Sprite({ img: img.page_thirteen_two, 
        sw: 2304, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageThree: new Sprite({ img: img.page_thirteen_three, 
        sw: 2304, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageFour: new Sprite({ img: img.page_thirteen_four, 
        sw: 2304, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageFive: new Sprite({ img: img.page_thirteen_five, 
        sw: 2304, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageSix: new Sprite({ img: img.page_thirteen_six, 
        sw: 2304, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageSeven: new Sprite({ img: img.page_thirteen_seven, 
        sw: 2304, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageEight: new Sprite({ img: img.page_thirteen_eight, 
        sw: 2304, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageFix: new Sprite({ img: img.page_thirteen_fix, 
        sw: 2304, sh: 1296, dw: 1152, dh: 648, alfa: 1
      }),
      progress: 0,
      disableClick: false,
      drawOne: true,
      drawTwo: false,
      drawThree: false,
      drawFour: false,
      drawFive: false,
      drawSix: false,
      drawSeven: false,
      drawEight: false,
      ohhEnabled: true,
      mhmEnabled: true,
    });
  }
};
levelStates.pageThirteen.mutable = levelStates.pageThirteen.immutable();

function pageThirteen() {
  var level = levelStates.pageThirteen.mutable;
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0) { 
    level.disableClick=true;
    level.progress++;
    mouseDown=[];
  };
  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }

  if (level.drawOne) {
    level.imageOne.draw();
  };

  if (level.drawTwo) {
    var alfaTwo = level.imageTwo.get("alfa");
    if (alfaTwo<1) { level.imageTwo.set({alfa: alfaTwo + level.imageFadeSpeed }) };
    level.imageTwo.draw();
  };

  if (level.drawThree) {
    var alfaThree = level.imageThree.get("alfa");
    if (alfaThree<1) { level.imageThree.set({alfa: alfaThree + level.imageFadeSpeed }) };
    level.imageThree.draw();
  };

  if (level.drawFour) {
    var alfaFour = level.imageFour.get("alfa");
    if (alfaFour<1) { level.imageFour.set({alfa: alfaFour + level.imageFadeSpeed }) };
    level.imageFour.draw();
  };

  if (level.drawFive) {
    var alfaFive = level.imageFive.get("alfa");
    if (alfaFive<1) { level.imageFive.set({alfa: alfaFive + level.imageFadeSpeed }) };
    level.imageFive.draw();
  };

  if (level.drawSix) {
    var alfaSix = level.imageSix.get("alfa");
    if (alfaSix<1) { level.imageSix.set({alfa: alfaSix + level.imageFadeSpeed }) };
    level.imageSix.draw();
  };

  if (level.drawSeven) {
    var alfaSeven = level.imageSeven.get("alfa");
    if (alfaSeven<1) { level.imageSeven.set({alfa: alfaSeven + level.imageFadeSpeed }) };
    level.imageSeven.draw();
  };

  if (level.drawEight) {
    var alfaEight = level.imageEight.get("alfa");
    if (alfaEight<1) { level.imageEight.set({alfa: alfaEight + level.imageFadeSpeed }) };
    level.imageEight.draw();
  };

  level.imageFix.draw();

  if (level.progress == 0) {
    fade.in();
    if (fade.get("progress")==0) level.progress = 2
  } else if (level.progress==2) {
    level.drawTwo = true;
  } else if (level.progress==3) {
    level.drawThree = true;
  } else if (level.progress==4) {
    level.drawFour = true;
  } else if (level.progress==5) {
    level.drawFive = true;
    if (soundOn  && level.ohhEnabled) {
      snd.ohh.play();
      level.ohhEnabled=false;
    }
  } else if (level.progress==6) {
    level.drawSix = true;
  } else if (level.progress==7) {
    level.drawSeven = true;
  } else if (level.progress==8) {
    level.drawEight = true;
    if (soundOn  && level.mhmEnabled) {
      snd.mhm.play();
      level.mhmEnabled=false;
    }
  } else if (level.progress>=9) {
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      current="pageFourtheen";
    }
  };

  linker({x: 0, y: 0});
  soundSwitch();
  bgMusic();

  helpClick(700, 450);
};

levelStates.pageFourtheen = {
  immutable: function() {
    return({ 
      imageFadeSpeed: 0.1,
      imageOne: new Sprite({ img: img.page_fourtheen_one, 
        sw: 2304, sh: 1296, dw: 1152, dh: 648, alfa: 1
      }),
      imageTwo: new Sprite({ img: img.page_fourtheen_two, 
        sw: 2304, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageThree: new Sprite({ img: img.page_fourtheen_three, 
        sw: 2304, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageFour: new Sprite({ img: img.page_fourtheen_four, 
        sw: 2304, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      progress: 0,
      disableClick: false,
      drawOne: true,
      drawTwo: false,
      drawThree: false,
      drawFour: false
    });
  }
};
levelStates.pageFourtheen.mutable = levelStates.pageFourtheen.immutable();

function pageFourtheen() {
  var level = levelStates.pageFourtheen.mutable;
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0) { 
    level.disableClick=true;
    level.progress++;
    mouseDown=[];
  };
  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }

  if (level.drawOne) {
    level.imageOne.draw();
  };

  if (level.drawTwo) {
    var alfaTwo = level.imageTwo.get("alfa");
    if (alfaTwo<1) { level.imageTwo.set({alfa: alfaTwo + level.imageFadeSpeed }) };
    level.imageTwo.draw();
  };

  if (level.drawThree) {
    var alfaThree = level.imageThree.get("alfa");
    if (alfaThree<1) { level.imageThree.set({alfa: alfaThree + level.imageFadeSpeed }) };
    level.imageThree.draw();
  };

  if (level.drawFour) {
    var alfaFour = level.imageFour.get("alfa");
    if (alfaFour<1) { level.imageFour.set({alfa: alfaFour + level.imageFadeSpeed }) };
    level.imageFour.draw();
  };

  if (level.progress == 0) {
    fade.in();
    if (fade.get("progress")==0) level.progress = 2
  } else if (level.progress==3) {
    level.drawTwo = true;
  } else if (level.progress==4) {
    level.drawThree = true;
  } else if (level.progress==5) {
    level.drawFour = true;
  } else if (level.progress>=6) {
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      current="pageSixteen"
    }
  };

  linker({x: 0, y: 0});
  bgMusic();

  helpClick(700, 450);
};

levelStates.pageSixteen = {
  immutable: function() {
    return({ 
      imageFadeSpeed: 0.1,
      imageOne: new Sprite({ img: img.page_sixteen_one, 
        sw: 2304, sh: 1296, dw: 1152, dh: 648, alfa: 1
      }),
      imageTwo: new Sprite({ img: img.page_sixteen_two, 
        sw: 2304, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageThree: new Sprite({ img: img.page_sixteen_three, 
        sw: 2304, sh: 1296, dw: 1152, dh: 648, alfa: 0
      }),
      imageEnd: new Sprite({ img: img.page_sixteen_end, 
        sw: 2304, sh: 1296, dw: 1152, dy: 648, dh: 648, alfa: 1
      }),
      progress: 0,
      disableClick: false,
      drawOne: true,
      drawTwo: false,
      drawThree: false,
      endDy: 648, 
      drawEnd: false,
      goToNewGame: false,
      resetGame: false,
    });
  }
};
levelStates.pageSixteen.mutable = levelStates.pageSixteen.immutable();

function pageSixteen() {
  var level = levelStates.pageSixteen.mutable;
  // navigate through level
  if (!level.disableClick && mouseDown.length > 0 && level.progress < 5) { 
    level.disableClick=true;
    level.progress++;
    mouseDown=[];
  };

  if (level.progress > 6) {
    level.progress = 6; 
  }
  if (level.disableClick) { 
    // small pause bf can click again
    setTimeout(function(){ level.disableClick = false }, timeBetweenClicks);
  }

  if (level.drawOne && level.progress<6) {
    level.imageOne.draw();
  };

  if (level.drawTwo) {
    var alfaTwo = level.imageTwo.get("alfa");
    if (alfaTwo<1) { level.imageTwo.set({alfa: alfaTwo + level.imageFadeSpeed }) };
    level.imageTwo.draw();
  };

  if (level.drawThree) {
    var alfaThree = level.imageThree.get("alfa");
    if (alfaThree<1) { level.imageThree.set({alfa: alfaThree + level.imageFadeSpeed }) };
    level.imageThree.draw();
  };

  if (level.progress == 0) {
    fade.in();
    if (fade.get("progress")==0) level.progress = 2
  } else if (level.progress==3) {
    level.drawTwo = true;
  } else if (level.progress==4) {
    level.drawThree = true;
  } else if (level.progress==5) {
    level.drawEnd = true;
    fade.out();
  } else if (level.progress >= 6) {
    fade.out();
    if (fade.get("progress")==100) {
      resetMutableState(current);
      current="intro";
    }
  };

  if (level.drawEnd) {
    if (level.endDy > 0) { 
      level.endDy -= 20;
      level.imageEnd.set({dy: level.endDy }) 
    };
    level.imageEnd.draw();


    level.goToNewGame = nextGameBttn.click(mouseDown);
    nextGameBttn.draw(mouseOver);
    if (level.goToNewGame) {
      window.open("https://wetpussygames.com/adult-games/kinky-two-part-2.html", '_blank');
    }

    level.resetGame = resetGameBttn.click(mouseDown);
    resetGameBttn.draw(mouseOver);
    if (level.resetGame) {
      level.progress = 6
    }
  };

  linker({x: 0, y: 0});
  bgMusic();
  if (level.progress < 5) { helpClick(450, 250) };
};
